.sz 10
.B "Ream: A User's Guide"
.nr PS 10
.br
Paul Dourish
.sp
Original January 1988.
.br
Last updated September 1991.
.sp 2
.nr PS 12
.B "1. Introduction"
.nr PS 10
.LP
\fIReam\fP stands for "read mail". It is a convenient tool for reading,
sending and processing mail messages. Unlike the other mail tools typically
supplied with UNIX\**
.FS
UNIX is a trademark of AT&T Bell Laboratories.
.FE
systems (e.g. \fI/bin/mail\fP, \fI/usr/ucb/Mail\fP, \fImailx\fP), \fIream\fP
is based on single-keystroke commands and a screen-oriented interface. The
intention is to allow sophisticated users to process their mail more
efficiently, while also providing a friendlier environment for casual or
naive users.
\fIReam\fP has been successfully compiled
and run on VAXen under
4.2 and 4.3 BSD and Ultrix,
SUNs under SUN UNIX 3.0 or later, Pyramids under OSx, Gould machines
(Powernodes and NP-1) under UTX, PDP-11 under 2.10BSD\**, Orions under OTS,
Sequents (Balance and Symmetry) under DYNIX, Masscomps under RTU,
Whitechapel MG1s under 42nix, Arete machines under ARIX (System V),
Alliants under 4.2BSD, MIPS under 4.3BSD,
HP-9000 under HP-UX, Cray X-MP under UNICOS
and GEC-63s under UX 5.3 (System V.2). In other words, it runs on just
about anything.
.FS
It's not at all certain that the current version of ream will still fit into
the restricted address space available on a PDP-11.
.FE
.\"
.\" The call to .he is here to make sure it doesn't start until page 2
.\"
.HD .\fBReam\fP: User's Guide..%.
.sp 2
.nr PS 12
.B "2. Normal Usage"
.nr PS 10
.LP
\fIReam\fP can be started in either "read mode" or "send mode".
Send mode is effectively a subsection of read mode, since you will want to
send messages from read mode (e.g. in reply to received messages). The two
modes of operation will be described separately.
.sp
.B "2.1. Send Mode"
.LP
To start it in send mode, simply type \fIream\fP followed by a list
of recipients (people to whom the message should be sent); e.g. to use
\fIream\fP to send a message to your friend Hagbard, you should type
.ce
\fIream\ \ hagbard\fP
Note that you can specify as many recipients as you like here, and send
mail to a list of people.
.LP
The process of sending mail in \fIream\fP is quite different from that
of systems like UCB Mail or mailx.
In older version of \fIream\fP, the sending operation was
quite separate, and performed by another program called \fIcompose\fP.
In versions of \fIream\fP after 4.0, the mail reader and mail sender have
been combined, so
that the time taken to enter "send mode" has been greatly reduced.
.LP
In \fIream\fP, the sending of mail is based around an editor. When you
want to send mail, \fIream\fP automagically creates the necessary header
fields in accordance with the various mail standards, and lets you edit
the messages exactly as it will arrive at the other end. Since everyone
has their own preference for editors, \fIream\fP looks to see what
value is stored in the variable EDITOR, and uses that editor if possible.
You should set this variable to be the name of your favourite editor.
For instance, if you use
MicroEMACS (ue) then you'd say
.ce
\fIsetenv\  EDITOR\  ue\fP
You could either type this on the command line, or, to make it more
permanent, add it to your \fI.login\fP file\**.
.FS
Actually, you can have a separate editor just for \fIream\fP; see the
section later on creating a startup file.
.FE
When you try to send a message from inside \fIream\fP, it will create
suitable header fields, create a \fImessage template\fP, and let you edit
it. You should enter the text of your message with the editor, correcting
mistakes as you go along, as you would normally. When your message is
complete, you should exit the editor in the normal way, and the message
will be sent. If, however, \fIream\fP thinks that you might have left
the editor prematurely, without saving the file, then it will tell you this
and ask what you want to do by displaying a message like:
.ce
\fISend, edit, list or quit? [selq]\fP
If you type `s', then the message will be sent as normal. If you enter
`e', then you will return to the editor \- this is useful if you left the
editor accidentally, and still want to edit the message. Typing 'l' will
display the document on the screen without the overhead of firing up
an editor, and entering `q'
will throw away the message (leaving a copy in your dead letter box,
normally \fI~/dead.letter\fP)
and leave send mode.
.LP
Exactly the same procedure is followed for composing, forwarding and
replying to messages (see below).
.sp
.B "2.2. Read Mode"
.LP
To read mail that has been sent to you, you should start \fIream\fP in
read mode. If you want to read new mail, stored in your system mailbox,
then you should just type \fIream\fP with no parameters. It will look
where it thinks your system mailbox should be; in the directory
/usr/spool/mail on BSD systems, or /usr/mail on System V. If your mailbox
is in some strange place, you can set that with the MAIL variable.
To fire up \fIream\fP on another mailbox, you should use the `-f' flag;
the format is \fIream -f \fP\fImailbox\fP, where mailbox is the name
of a file or message folder. (Folders are explained in more detail further
on.)
.LP
Once the startup file has been read, \fIream\fP should display a list of
mail headers on the screen, telling you about the messages in the current
folder. One of the messages should be highlighted in some way, probably
in reverse video; this is the \fIcurrent message\fP, and most commands
will act upon it. The details that should be displayed for each message are:
.IP \(bu\ status
each message has a one-character status code. By default, the status
is marked by one of `N'
(indicating a new message), `U' (indicating an old but unread message),
`*' (indicating a message which has been marked for deletion, and will be
deleted when you leave this folder), or blank (indicating a message which
has been read, but will not be deleted). Note that messages which were
originally from you are automatically marked as read.
.IP \(bu\ number
a number is displayed, indicating this message's position in the file. This
number is used to identify the message in line mode (see below).
.IP \(bu\ sender
the name and/or mail address of the person who sent the message is displayed
next. If the sender of the message matches a name specified in the
\fIalternates\fR list (see section 3.3.5),
then \fIream\fP will print \fITo:\fP and
display the name of the recipient of the message.
.IP \(bu\ timestamp
an abbreviated form of the day and date on which the message was
received is displayed next.
.IP \(bu\ subject
finally, the subject of the message is displayed, inside double-quotes.
.LP
This display is called the \fIheader screen\fP, and is the default display
for \fIream\fP. It is now ready to accept commands from you. The details
of the commands are listed below, in the \fBCommands\fP section. Each command
has a name and a sequence of characters associated with it. This sequence
of characters is known as its \fIkey binding\fP, and they are the characters
you will normally enter to invoke the command. For instance, the default
key binding for the command \fInext\fP, to move you to the next message, is
`n', so to execute the \fInext\fP command, you should just press the `n'
key (no need to hit RETURN). If you don't like the default key
binding for a command, you can change it by using the \fBbind\fP command,
either from inside \fIream\fP, in which case its effect will only last until
you exit, or in your startup file, in which case it will remain until you
remove it. (See later for details about the startup file.)
All the commands should be available with
single-key bindings, so that you can access them easily. Invoking commands
by their key bindings is called \fIkey mode\fP, and is the normal mode
of operation in \fIream\fP. See later on for a description of another mode
of command entry (\fIline mode\fP)..
.sp
.\" This number (2.2.1) is refered to in the section on the autosave
.\" command. If it changes, then change the reference too. Give us
.\" TeX, they cry.
.B "2.2.1. Commands
.LP
Here is a list of commands available in \fIream\fP, along with their default
key bindings.
.IP \fBnext\fP 0.8i
(default binding `n')
Moves the current message pointer ahead onto the next message (if
any). If there are more messages in the folder than are displayed on the
screen, and you move to the next from the bottom of the screen, then
\fIream\fP will display the next screenful. If there are no more messages,
an error will be reported (unless you have the \fBwrap\fP option set, in which
case you will be moved to the first message in the folder; see the \fBStartup
File\fP section below).
.IP \fBprevious\fP 0.8i
(default binding `p')
Move the current message pointer back onto the previous message (if
any). If you're at the top of the screen but not at the first message, then
\fIream\fP will scroll back to the previous screenful. If there are no more
messages, an error will be reported (unless you have the \fBwrap\fP option
set, in which case you will be moved to the last message in the folder).
.IP \fBnext-page\fP 0.8i
(default binding `N')
As \fInext\fP, but moves forward by a screenful at a time.
.IP \fBprevious-page\fP 0.8i
(default binding `P')
As \fIprevious\fP, but moves back by a screenful at a time. 
.IP \fBtype\fP 0.8i
(default binding `RETURN')
Display the contents of a message on the screen. In the absence of any
parameters, the current message will be shown. Messages are displayed using
a pager program, which defaults to \fImore\fP.
After a \fItype\fP, the message is marked as read.
.IP \fBscan\fP 0.8i
(default binding `SPACE')
Move the current message pointer to the next unread message,
and type it using the \fItype\fP command.
.IP \fBsearch\fP 0.8i
(default binding `/')
Searches for a message containing a given regular expression (see
.I "ed(1)"
for details of regular expression syntax),
starting with the current message. If such a message is found, then it
is made the current message. Otherwise an error is reported.
.IP \fBdelete\fP 0.8i
(key `d')
Mark messages (either the current message, or the messages
specified as parameters) as deleted. This means that when you \fIquit\fP,
the messages will be removed from the file. Messages marked for deletion are
indicated with a `*' as their status code on the header screen.
.IP \fBundelete\fP 0.8i
(default binding `u')
As \fIdelete\fP, but this removes the deletion status from messages.
.IP \fBsave\fP 0.8i
(default binding `s')
Store the contents of a message in a file or folder (see the \fBFolders\fP
section for an explanation). You will be prompted to enter the name of a file.
Note that you can refer to a file in your home directory using the `~'
notation (like
.I "csh" ).
By default, and
if the current folder is your system mailbox, then messages are marked for
deletion once they've been saved or written.
.IP \fBwrite\fP 0.8i
This command behaves like \fBsave\fP except that only the text of the message
is stored in the file; the headers are ignored.
.IP \fBfolder\fP 0.8i
(default binding `f')
Change to a new folder. If you have made any changes to this
folder (by marking messages for deletion), you will be asked if you want
to update the copy on disk before the new folder is loaded. You may specify
files in your home directory using the `~' notation.
.IP \fBforward\fP 0.8i
(default binding `F')
Forward the current message to a list of recipients, using send mode.
.IP \fBcompose\fP 0.8i
(default binding `c')
Compose a message to be sent to a list of recipients, using send mode.
.IP \fBreply\fP 0.8i
(default binding `r')
Reply the the sender of the current message, using send mode.
Note that this version will reply only to the
sender of the original message, and not to all the recipients; if you
want to reply to everyone, you must use the command...
.IP \fBReply\fP 0.8i
(default binding `R')
Reply to a message, sending the reply to all recipients of the original
message.
.IP \fBpipe\fP 0.8i
(default binding `|')
Pipe a message through a UNIX command line (the default
is \fBlpr\fP, to send the message to the local printer; see the \fBStartup
File\fP section on how to change it). 
.IP \fBbind\fP 0.8i
(key `b')
Bind a command name to a given key sequence. Key bindings produced this
way will disappear at the end of the session. If you want to change a
key binding semi-permanently, you should put a \fIbind\fP command in
your startup file (see below).
.IP \fBpush\fP 0.8i
(default binding '>')
Pushes a "view" -- see the section on \fBViews\fP for further details.
.IP \fBpop\fP 0.8i
(default binding '<')
Removes the top view.
.IP \fBset-variable\fP 0.8i
(default binding `v')
Set (or examine) the value of a named variable. You can either use this
to set a new variable for the first time, or to reset the value of one
set in the startup file.
.IP \fBtag\fP 0.8i
(default binding `t')
Add an arbitrary text string (a "tag") to a message.
.IP \fBuntag\fP 0.8i
Remove a named tag from a message.
.IP \fBline-mode\fP 0.8i
(default binding `:')
Enter a command in line-mode, by specifying its name fully.
See the discussion of line mode vs key mode in the section on more
advanced features.
.IP \fBshell\fP 0.8i
(default binding `!')
Run a shell command.
.IP \fBhelp\fP 0.8i
(default binding `?')
Display the help screen, listing all the current key bindings.
.IP \fBredisplay\fP 0.8i
(default binding `^L')
Redraw the current screen display. This is useful if a message from the
system or another user has left garbage on your screen.
.IP \fBexit\fP 0.8i
(default binding `x')
Leave \fIream\fP without updating the current folder.
.IP \fBquit\fP 0.8i
(default binding `q')
Update the current folder, removing all deleted messages. All
other messages are left in the folder.
.LP
In addition, you can select a new message to be the current message by typing
its number (key mode only).
.sp 2
.nr PS 12
.B "3. More Advanced Facilities"
.nr PS 10
.sp
.B "3.1. Folders"
.LP
Folders are files for storing mail messages. They are kept in a separate
directory so that \fIream\fP can find them. Normally, this is the subdirectory
\fImail\fP in the user's home directory, but it can be changed using the
\fIFOLDERS\fP environment variable, or the \fIfolders\fP internal
\fIream\fP variable to specify some other directory (see the section on the
\fBStartup File\fP).
When \fIream\fP prompts you for a file name (e.g. to save a message), you can
specify a folder by preceding the filename with a `+' sign. Thus
\fIin-tray\fP specifies the file called in-tray in the current directory,
while \fI+in-tray\fP specifies the file called in-tray in the folders
directory. By using folders, you can ensure that you know where old
messages are, and can find them again quickly and easily.
.sp
.B "3.2. Compose"
.LP
\fIReam\fP can be forced to enter \fIsend mode\fP if it is called by the name
\fIcompose\fP. You will get this behaviour if you make a link to your copy of
\fIream\fP with the name \fIcompose\fP. As well as accepting a list of
recipients on the command like (just like \fIream\fP), \fIcompose\fP also
understands the following options:
.IP \fB-f\fP 0.8i
Forward a message. \fICompose\fP will accept a message on the standard input
and forward it to the list of recipients given on the command line.
.IP \fB-r\fP 0.8i
Reply to a message. \fICompose\fP will accept a message on the standard input
and reply to it.
.IP \fB-t\fP 0.8i
Force \fIcompose\fP to prompt for the recipient list (the "To:")
field. This is useful if you can't give command-line arguments, e.g. if
you're calling compose from a menu.
.LP
These options are useful if you want to use \fIcompose\fP to forward and
reply to messages which cannot be read with \fIream\fP, such as network
news articles.
.sp
.B "3.3. Startup File"
.LP
Every time \fIream\fP starts up, it looks for a file called \fI.reamrc\fP
in your home directory. This file contains commands which will alter the
way in which \fIream\fP works during that session. There are basically
five types of lines you can put in your startup file:
.sp
3.3.1 Field commands
.LP
Lines beginning with the word "field" are taken to contain header
lines to be included in outgoing mail messages. For instance, to stamp all
outgoing mail messages with your organisation, then you could include the
line
.ce
\fIfield Organisation: God's Lightning, Mad Dog, Texas.\fP
Inside a \fBfield\fP command, the string \(lq%v\(rq will be replaced
with the number of the current version of \fIream\fP. You can use this to
put out an \fIX-Mailer\fP field and be sure that the version number is up
to date.
Also useful in that field is \(lq%m\(rq, which is translated into the name
of your local mail delivery agent \- normally \fISendmail\fP or \fIMMDF\fP.
For instance, I use the line
.ce
\fIfield X-Mailer: %m/Ream v%v (The Choice for a New Generation)\fP\**
.FS
The reason for the "X-" which you see at the beginning of this and other
headers is that fields which begin with that string are guaranteed by the
various mail standards not to conflict with official fields.
.FE
You can also use the strings "%u" and "%f" in \fIfield\fP
commands; they will be translated into
your username and full name respectively.
.sp
3.3.2 Bind commands
.LP
Lines beginning with the word "bind" introduce command name bindings
which will override the defaults. For instance, if you'd prefer to use
CTRL-P and CTRL-N to move to the previous and next messages respectively
(instead of the default `p' and `n'), then you should add the lines:
.ID
\fIbind previous ^P
bind next ^N\fP
.DE
to your \fI.reamrc\fP file. Note that control characters are represented
in the startup file by the two character sequence `^' (\fIcarat\fP)
followed by the character name. Under this scheme, ESC is represented as ^[.
So, if you always use an ANSI terminal, you might like to bind the movement
commands to the arrow keys, with
.ID
\fIbind previous ^[[A
bind next ^[[B\fP
.DE
.sp
3.3.3 Alias commands
.LP
Lines beginning with the word "alias" contain mail aliases to be
used when sending mail. For instance, if you have the line
.ce
\fIalias celine hagbard@ldd.org\fP
in your startup file, then all mail addresses to "celine" will actually
be sent to "hagbard@ldd.org". You can use the alias facility to create
a \fIdistribution list\fP by having a number of mail addresses in a single
alias. Thus, if you have the alias
.ce
\fIalias discordians celine george mavis stella \fP
then you can mail to all of celine, george, mavis and stella at once , just by
using the address "discordians".
.LP
This is the same as the alias facility
in UCB Mail; in fact, aliases are also read from \fI.mailrc\fP, UCB Mail's
startup file. The recipient names referred to by an alias can themselves
be aliases. Long aliases can be broken up over a number of lines by escaping
the end-of-lines with the backslash character (`\\'). Aliases can hold not
only the mail address of the recipient, but also comment information (usually
the full name). In a mixed address like this, the actual address is identified
by enclosing it in angle-brackets. When defining an alias like this,
quotes must be put around the
name to protect the spaces. So, you can have an alias like:
.ce
\fIalias ah "Atlanta Hope <atlanta@aisb.org>"\fP
See the description of the \fIlocalnames\fP variable below.
.sp
3.3.4 File commands
.LP
Lines beginning with the word "file" introduce redirections in the
system which automatically generates names for folders when using the
\fBsave\fP command (see section 2.2.1). Normally, \fBsave\fP will generate
a foldername based on the user name of the person who sent you the mail;
you can use \fIfile\fP to override those defaults and specify a new
foldername for mail from given users, or to certain addresses. For instance,
if you want to save mail from George Dorn, whose username is gdorn, into
\fI+george\fP instead of the default \fI+gdorn\fP, then you can say:
.ce
\fIfile gdorn +george\fP
Note that this will save all mail from any person called "gdorn" (or
from any of his accounts); you can restrict it by saying something like:
.ce
\fIfile gdorn@kallisti.uucp +george\fP
which will make sure that the mail is from his account on kallisti.
You can also change the default foldername for mail which was addressed to
a particular address, such as a mailing list, using the syntax:
.ce
\fIfile {to: jams} +mummu\fP
which will change the default for mail sent to the address \fIjams\fP to be
the folder \fI+mummu\fP.
Finally, you can change the default file for a message according to
the "subject" field:
.ce
\fIfile {subject: change request} +changes\fR
.LP
For compatability with previous versions of \fIReam\fP, the alternative
command "autosave" is still supported with the old syntax. New users
should use "file" instead.
.sp
3.3.5 Alternates commands
.LP
Alternates commands are used to specify mail addresses which
correspond to yourself. If you set some number of names as alternates,
then \fIream\fR will attempt to recognise them in the headers of mail
messages, and will show the recipients of those messages in the
headers rather than yourself as the sender.
.LP
Any number of alternate addresses cam be specified (so that you can
identify old mail addresses as well as multiple current ones). To
specify an address, enter a line beginning \fIalternates\fR and
continuing with addresses in your \fI.reamrc\fR. For example,
.ce
\fIalternates Dourish@EuroPARC.Xerox.COM jpd@uk.ac.edinburgh.aiai\fR
will set those two addresses as alternates. You can have multiple
alternates lines in your \fI.reamrc\fR file.
.sp
3.3.6 Set commands
.LP
Set commands can be used to set the values of variables (which can be
looked up from inside \fIream\fP), or to set options, which control the
system's behaviour in more obvious ways. To set an option, the syntax is
.ce
\fIset \fP\fIoptionname\fP
while, to set a variable, the syntax is
\fIset \fP\fIvariablename\fP\fI=\fP\fIvalue\fP
The following options are recognised by \fIream\fP:
.IP \fBadvance-on-delete\fP 0.8i
This option causes ream to move to the next message when a message is
deleted.
.IP \fBask\fP 0.8i
setting this option will cause \fIream\fP
to prompt you for the subject of outgoing
messages
.IP \fBaskcc\fP 0.8i
this option is similar to \fIask\fP, but controls whether \fIream\fP will
prompt you to give a list of addresses to recieve copies of an outgoing
message (ie to be added to the "Cc:" field).
.IP \fBconfirm-create\fP 0.8i
this variable forces \fIream\fP to check all file creations. When a
new file is being created, the user will be prompted to confirm that
this is appropriate.
.IP \fBlocalnames\fP 0.8i
with this variable set, \fIream\fP will automatically expand local recipient
names with information (usually the person's full name) gleaned from the
password file. So, if you specify the recipient \fIjpd\fP, then on machines
where jpd has an account (and is me!) it would be expanded to
\fIPaul Dourish <jpd>\fP.
.IP \fBmetoo\fP 0.8i
when this variable is set, you are added to the recipient list of all
messages you send out, and so you receive a copy by mail.
.IP \fBnopause\fP 0.8i
normally, after invoking the pager (e.g. when \fItype\fP-ing a message), 
\fIream\fP will pause and ask you to press a key before returning to the
header screen; this is to prevent messages flying off the screen faster
than you can read them. However, some pagers
(e.g. \fIless\fP)
will automatically stop at the
bottom of a message anyway, so there's no need for this. If \fBnopause\fP
is set, then \fIream\fP will immediately return from a pager, without
asking you to press a key.
.IP \fBreckless\fP 0.8i
This option suppresses the "update folder" question which \fIream\fP normally
asks before executing \fIquit\fP or \fIfolder\fP commands. When it's set,
the command proceeds and updates without asking the user for confirmation.
.IP \fBreplyall\fP 0.8i
This option exchanges the actions of the \fIreply\fP and \fIReply\fP commands.
When \fBreplyall\fP is set, the normal \fIreply\fP command replies to
\fIall\fP recipients of the original message, as opposed to just the sender,
Which is the normal behaviour. The "reply to sender" operation is
then performed by the \fIReply\fP command.
.IP \fBskipheaders\fP 0.8i
Setting this option changes the way that ream behaves when a message
has been displayed. Instead of returning directly to the header
screen, it will give you the option of carrying on to read the next
unread message (if there is one).
.IP \fBvisible\fP 0.8i
This option causes \fIream\fP to use the visible bell (instead of the audio
one) when possible
.IP \fBwrap\fP 0.8i
Setting \fBwrap\fP allows
the \fInext\fP and \fIprevious\fP
commands to "wrap around" the messages (ie when you ask for the
next message when you're already on the last one, you'll move to the first).
.LP
The following variables can be set in the \fI.reamrc\fP file (though most
should have reasonable default values):
.IP \fBautodelete\fP 0.8i
Setting this causes folder to be automatically deleted when they become empty.
The default behaviour is for the user to be prompted about whether or not to
delete them. Possible values are \fIalways\fP, \fInever\fP and \fIask\fP.
.IP \fBconfirm\fP 0.8i
You can use this flag to ensure that \fIream\fP will always ask you to
confirm a message before sending it, with the "send/edit/list/quit" question.
To get this behaviour, set \fBconfirm\fP to \fIalways\fP.
.IP \fBdead\fP 0.8i
This variable should be set to the name of the file where unset ("dead")
messages are stored. The default is \fI~/dead.letter\fP.
.IP \fBdelete-on-save\fP 0.8i
When this variable has the value \fInever\fP, messages are not marked
for deletion when they are saved, even if the current folder is the
system mailbox.
.IP \fBeditor\fP 0.8i
The program named by \fBeditor\fP is used to edit messages before they are
sent; it defaults to the value of the environment variable $EDITOR, or
\fIvi\fP if that is not set.
.IP \fBfolders\fP 0.8i
The value of the \fBfolders\fP variable is used as the directory in which to
look for folders (see the "Folders" section for more details); it defaults
to the value of the $FOLDERS environment variable, or a subdirectory
\fImail\fP in your home directory if $FOLDERS is not set.
.IP \fBforwardedit\fP 0.8i
This variable controls whether you edit messages before you forward them.
Possible values are \fIalways\fP, \fIusually\fP, \fIsometimes\fP and
\fInever\fP. The default is \fIalways\fP, which causes \fIream\fP to
invoke the editor on the draft forwarded message before sending it. Setting
\fIforwardedit\fP to \fInever\fP, or saying \fIunset forwardedit\fP, will
cause \fIream\fP to just send the message without editing it first. If
it's set to either of the two other values, then you'll be asked whether
or not you want to edit the draft. If \fIforwardedit\fP is set to
\fIusually\fP, then the answer to this question defaults to "yes"; if set to
\fIsometimes\fP, then then default answer is "no".
.IP \fBforward-indent\fP
This variable can contain a string which will be used to indent messages
on forwarding. When set, it overrides the value of the \fIindent\fP
variable (see below).
.IP \fBinclude\fP 0.8i
The \fBinclude\fP variable can cause \fIream\fP to include the original
message when composing a reply. Possible values are \fIalways\fP (equivalent
to just saying \fBset include\fP), \fInever\fP (equivalent to not setting
it at all), \fIusually\fP and \fIsometimes\fP. These values produce
equivalent behaviours to the corresponding values of the \fIforwardedit\fP
variable.
.IP \fBindent\fP 0.8i
The value of \fBindent\fP is the string which is placed at the beginning
of every line on included text (e.g. text from a message to which you're
replying, or that you're forwarding). The default value is "> ".
.IP \fBmbox\fP 0.8i
The value of mbox is a file to which all read mail should be saved
when the user quits from \fIream\fP. This reproduces the behaviour of
the UCB Mail program, which saves all such messages to a file called
"mbox" in the user's home directory.
.IP \fBpager\fP 0.8i
The program named by this variable is used when displaying messages; it 
defaults to the value of the environment variable $PAGER, or \fImore\fP if
that is not set.
.IP \fBpipe\fP 0.8i
The value of the \fBpipe\fP variable is used as the command through which
messages will be piped by default when the \fIpipe\fP command is used (if
you don't set it, this will normally default to \fIlpr\fP).
.IP \fBrecord\fP 0.8i
Setting \fBrecord\fP to some filename will cause \fIream\fP to save copies
of all your outgoing mail in that file. If you set it to the string
\fI+%t\fP, then the filename to save the file to will be calculated from the
recipient address of the message (eg messages to "atlanta" will be saved in
\fI+atlanta\fP).
.IP \fBsendmail\fP 0.8i
The program named in the \fBsendmail\fP variable is used to deliver mail
messages (e.g. \fI/bin/mail\fP or \fI/usr/lib/sendmail\fP).
.IP \fBstatusmarks\fP 0.8i
This variable controls the characters that are used to indicate the
message status on the header screen. It should be a five-character
string, where the characters are the codes for new, unread, read,
replied-to and deleted, respectively. The default is \(lqNU R*\(rq.
.LP
.SH 3.3.7 Ignore commands
.LP
Lines beginning with the word "ignore" indicate the names of header fields
which are to be ignored when the message is printed, thus reducing the size 
of the header. For instance, if you wanted to suppress the printing of the
fields "Message-Id" and "Received", then you would use the command:
.ce
\fIignore Message-Id Received\fP
You can have as many \fIignore\fP commands as you like, and can continue
across multiple lines in the usual way. The field names specified in an
\fIignore\fP command may optionally include the trailing colon (`:'), but
if you don't specify it, \fIream\fP will add it automatically.
.LP
Note that the printing of ignored fields is only suppressed when the
\fItype\fP or \fIscan\fP commands are used; the fields will still be passed
to pipes and saved to files, for example.
.sp
.LP
A hash characters (`#') in the first column introduces a comment line, which
is ignored by \fIream\fP; you can use comments to make the contents of your
startup file more readable.
.sp
.\" Look out! I'm going to refer to this section number directly...
.B "3.4. Line Mode"
.sp
Until now, the only command-entry mode which has been described is
\fIkey\fP mode, in which the key bindings associated with each command
are entered.
However, there is an alternative, called
\fIline mode\fP, which allows you to enter the full command name\**.
.FS
In fact, you need only type as many characters as are needed to
unambiguously specify the command name. For instance, \fBtype\fP is the
only command beginning with `t', so just using `t' will suffice; hitting
SPACE or RETURN will cause \fIream\fP to complete the command name.
.FE
The advantage of this mode is that, rather than having the commands act only
on the currently selected message, they can be made to act on any message
or groups of messages by specifying a \fImessage list\fP as a parameter.
For instance, suppose you wanted to delete all the messages between 5 and 17.
In key mode, you would have to move to each message individually, and press
the `d' key to delete them. However, in line mode, you could just say
\fIdelete 5-17\fP, and have \fIream\fP do the work. The parameter (in
this case 5-17) can be any message list. A message list is a list of
message specifiers, which can be any of
.np
a message number (e.g. `23'), or "." to refer to the current message,
or "$" to refer to the last message;
.np
a range of message numbers (e.g. `5-17', `.-$')
.np
a star (`*'), meaning all messages
.np
a pattern, in braces (`{' and `}'). Patterns can either be the name of the
sender of the message, the name of the primary recipient of the message,
a tag associated with the message,
or a substring from the subject of the message.
Recipient patterns are distinguished by beginning with "To:";
tag patterns by beginning with "Tag:";
and subject patterns by beginning with a colon (`:').
Thus \fI{George Dorn}\fP would refer to all
messages from George Dorn;
\fI{to: hagbard}\fP to all messages to hagbard;
\fI{:Leif Erikson}\fP to all those which mention
"Leif Erikson" in their subjects;
and \fI{tag: malaclypse}\fP to all those which you have tagged with the
string "malaclypse".
Note that when doing a sender match, you can match to either the mail
address of the user, or the "comment" part of the field, normally
containing his or her full name (as shown in the examples).
The is no way to combine patterns (e.g. to search for all message from
hagbard and tagged \fImalaclypse\fP).
.LP
Thus the command \fIdelete 2, 3-5, 17, 23\fP would delete messages numbered
2, 3, 4, 5, 17 and 23.
Any command which acts on a message in key mode can be made to take a
message list as a parameter in line mode.
.sp
.B "3.5 Views"
.LP
If you receive a lot of mail, or you're processing a large folder, you may
find it inconvenient to have to deal with messages in the order in which
they arrived. The \fIviews\fP system has been designed to help with this
problem, by allowing you to deal with groups of related messages together.
Put simply, a view is a pattern through which you see your folder. Messages
which do not match the pattern are hidden, so that you only see (and
process) those which are of immediate interest. These might be all the
message on a given subject, or all the ones sent to a particular address (eg
a mailing list). Any number of views can be active concurrently, with each
one filtering out messages from the one below.
.LP
To place a view on a folder, use the \fBpush\fP command, and give it as an
argument the pattern of messages which you want to concentrate on. For
example, to concentrate on the messages which you've been sent about
Leviathan, you would type:
.ce
\fB:push {:leviathan}\fP
The result of this should be that the screen will be redrawn and only
messages mentioning "leviathan" in their subjects should be shown. At the
top of the screen, a star (`*') should be displayed to indicate that you're
inside a view. Further \fBpush\fP commands will put moe views on top of this
one. All message references are now "narrowed" to the messages you can see,
so that the `*' wildcard will only match those messages in the current view,
and numbers reference messages by their position in this view. While you're
inside a view, the automatic mailbox update process is switched off, so that
new mail won't interfere with your view.
.LP
You can leave the view by typing \fB:pop\fP or using your binding for this
command. Note that you must leave all views which you have pushed onto the
folder before you can leave the folder or quit \fIream\fP.
.sp 2
.nr PS 12
.B "4. Bugs"
.nr PS 10
.LP
\fIReam\fP is still a relatively new program, and so there are probably still
some bugs in it. If you come across some unexpected behaviour which seems
like a bug, please let me know so that I can investigate it and (hopefully)
incorporate a fix into the next release. You can reach me at:
.ID
Rank Xerox EuroPARC\**,
61 Regent St,
Cambridge
CB2 1AB
UK.
.DE
or by electronic mail at:
.ID
Internet: dourish@europarc.xerox.com
.DE
.FS
Ream is entirely a private development, and has nothing to do with
Xerox other than that I work for them. Most of the development was done
while I worked at the University of Edinburgh.
.FE
